CorelPainterParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
CorelPainterParser Class Referencefinal

the main class to read a Painter's file, actually, read Fractal Design Painter 1-4, MetaCreation v5-v6 and Corel Painter v7-v10 Mac files and Fractal Design Painter 3 Windows files. More...

`#include <CorelPainterParser.hxx>`

Inheritance diagram for CorelPainterParser:

## Public Member Functions
| CorelPainterParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~CorelPainterParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGDrawingInterface *documentInterface) final
| the main parser function More...
Public Member Functions inherited from MWAWGraphicParser
| ~MWAWGraphicParser () override
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
const MWAWPageSpan & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGDrawingInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | sendBitmap (CorelPainterParserInternal::ZoneHeader const &zone)
| try to send a bitmap zone (main bitmap or floater) More...
bool | sendZone (CorelPainterParserInternal::ZoneHeader const &zone)
| try to send a not bitmap zone More...
bool | createZones ()
| finds the different objects zones More...
std::shared_ptr< CorelPainterParserInternal::Node > | readCompressionTree (long endPos, int numNodes)
| try to read the Hoffman tree More...
bool | decompressData (CorelPainterParserInternal::ZoneHeader const &zone, long endPos, int &value, int &buffer, int &numBitsInBuffer)
| try to decompress a data More...
bool | readZoneHeader (CorelPainterParserInternal::ZoneHeader &zone)
| try to read the header zone More...
std::shared_ptr< MWAWPict > | readBitmap (CorelPainterParserInternal::ZoneHeader const &zone)
| try to read a bitmap More...
bool | readBitmapRow (CorelPainterParserInternal::ZoneHeader const &zone, std::vector< MWAWColor > &colorList, std::vector< unsigned char > &previousValues)
| try to read a bitmap line More...
bool | readResourcesList (CorelPainterParserInternal::ZoneHeader &zone)
| try to read the list of resource zone (in the data fork) More...
bool | readResource (MWAWEntry &entry)
| try to parse the resource data More...
bool | sendText (MWAWEntry const &entry, MWAWEntry const &unicodeEntry)
| try to parse the text data More...
bool | readPolygon (long endPos, MWAWGraphicShape &shape, MWAWGraphicStyle &style)
| try to read a polygon data More...
MWAWPosition | getZonePosition (CorelPainterParserInternal::ZoneHeader const &zone) const
| update the position beforing sending a bitmap, shape, ... More...
bool | readDouble (double &res)
| try to read a double 1 bytes exponent, 3 mantisse More...
Protected Member Functions inherited from MWAWGraphicParser
| MWAWGraphicParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWGraphicParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
const std::string & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< CorelPainterParserInternal::State > | m_state
| the state More...

## Friends
class | CorelPainterParserInternal::SubDocument

## Detailed Description

the main class to read a Painter's file, actually, read Fractal Design Painter 1-4, MetaCreation v5-v6 and Corel Painter v7-v10 Mac files and Fractal Design Painter 3 Windows files.

## Constructor & Destructor Documentation

## ◆ CorelPainterParser()

CorelPainterParser::CorelPainterParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~CorelPainterParser()

CorelPainterParser::~CorelPainterParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool CorelPainterParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void CorelPainterParser::createDocument | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool CorelPainterParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ decompressData()

bool CorelPainterParser::decompressData | ( | CorelPainterParserInternal::ZoneHeader const & | zone,
|  | long | endPos,
|  | int & | value,
|  | int & | buffer,
|  | int & | numBitsInBuffer
| ) |  |
| protected

try to decompress a data

Referenced by readBitmapRow().

## ◆ getZonePosition()

MWAWPosition CorelPainterParser::getZonePosition | ( | CorelPainterParserInternal::ZoneHeader const & | zone | ) | const
| protected

update the position beforing sending a bitmap, shape, ...

Referenced by sendBitmap(), and sendZone().

## ◆ init()

void CorelPainterParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by CorelPainterParser().

## ◆ parse()

void CorelPainterParser::parse | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| finalvirtual

the main parser function

Implements MWAWGraphicParser.

## ◆ readBitmap()

std::shared_ptr< MWAWPict > CorelPainterParser::readBitmap | ( | CorelPainterParserInternal::ZoneHeader const & | zone | ) |
| protected

try to read a bitmap

Referenced by sendBitmap().

## ◆ readBitmapRow()

bool CorelPainterParser::readBitmapRow | ( | CorelPainterParserInternal::ZoneHeader const & | zone,
|  | std::vector< MWAWColor > & | colorList,
|  | std::vector< unsigned char > & | previousValues
| ) |  |
| protected

try to read a bitmap line

Referenced by readBitmap().

## ◆ readCompressionTree()

std::shared_ptr< CorelPainterParserInternal::Node > CorelPainterParser::readCompressionTree | ( | long | endPos,
|  | int | numNodes
| ) |  |
| protected

try to read the Hoffman tree

Referenced by readZoneHeader().

## ◆ readDouble()

bool CorelPainterParser::readDouble | ( | double & | res | ) |
| protected

try to read a double 1 bytes exponent, 3 mantisse

Referenced by sendText().

## ◆ readPolygon()

bool CorelPainterParser::readPolygon | ( | long | endPos,
|  | MWAWGraphicShape & | shape,
|  | MWAWGraphicStyle & | style
| ) |  |
| protected

try to read a polygon data

Referenced by sendZone().

## ◆ readResource()

bool CorelPainterParser::readResource | ( | MWAWEntry & | entry | ) |
| protected

try to parse the resource data

Referenced by readResourcesList().

## ◆ readResourcesList()

bool CorelPainterParser::readResourcesList | ( | CorelPainterParserInternal::ZoneHeader & | zone | ) |
| protected

try to read the list of resource zone (in the data fork)

Referenced by createZones().

## ◆ readZoneHeader()

bool CorelPainterParser::readZoneHeader | ( | CorelPainterParserInternal::ZoneHeader & | zone | ) |
| protected

try to read the header zone

Referenced by checkHeader(), and createZones().

## ◆ sendBitmap()

bool CorelPainterParser::sendBitmap | ( | CorelPainterParserInternal::ZoneHeader const & | zone | ) |
| protected

try to send a bitmap zone (main bitmap or floater)

Referenced by parse().

## ◆ sendText()

bool CorelPainterParser::sendText | ( | MWAWEntry const & | entry,
|  | MWAWEntry const & | unicodeEntry
| ) |  |
| protected

try to parse the text data

## ◆ sendZone()

bool CorelPainterParser::sendZone | ( | CorelPainterParserInternal::ZoneHeader const & | zone | ) |
| protected

try to send a not bitmap zone

Referenced by parse().

## Friends And Related Function Documentation

## ◆ CorelPainterParserInternal::SubDocument

friend class CorelPainterParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<CorelPainterParserInternal::State> CorelPainterParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), getZonePosition(), init(), parse(), and sendZone().

The documentation for this class was generated from the following files:

- CorelPainterParser.hxx
- CorelPainterParser.cxx